package ca.mcgill.sel.aspectoptima.aspects.checkpointable;

import java.lang.annotation.Documented;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;
import java.lang.annotation.ElementType;

/**
 * Marks a method as Checkpointable for the AspectOPTIMA Framework<br>
 * Objects containing Checkpointable methods should be annotated with @CheckpointableClass.
 */
@Target( { ElementType.METHOD })
@Documented
@Retention(RetentionPolicy.RUNTIME)
public @interface CheckpointableMethod {
	// empty
}