package ca.mcgill.sel.aspectoptima.aspects.checkpointing;

import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * Marks an object as Checkpointed for the AspectOPTIMA Framework. <br>
 * The needed annotation @CheckpointableClass is added automatically. <br>
 * Methods of Checkpointed objects can be marked as Checkpointed using @CheckpointedMethod. <br>
 */
@Target({ElementType.TYPE}) 
@Documented
@Retention(RetentionPolicy.RUNTIME)
public @interface CheckpointedClass {
	// empty
}