package ca.mcgill.sel.aspectoptima.aspects.deferring;

import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * Marks an object as Deferred for the AspectOPTIMA Framework. <br>
 * The needed annotations @DeferrableObject and @TracedClass are added automatically. <br>
 * Methods of Deferred objects can be marked as Deferred using @DeferredMethod.
 */
@Target({ElementType.TYPE}) 
@Documented
@Retention(RetentionPolicy.RUNTIME)
public @interface DeferredClass {
	// empty
}