package ca.mcgill.sel.aspectoptima.aspects.lockable;

import java.io.Serializable;
import java.util.concurrent.locks.ReadWriteLock;
import java.util.concurrent.locks.ReentrantReadWriteLock;

import ca.mcgill.sel.aspectoptima.aspects.accessclassified.AccessKind;

public interface Lock extends Serializable {
	// public method signatures from structural view
	// empty
}

aspect LockAspect {
	// attributes & associations from structural view
	// empty
	// BEGIN implementation refinement
	transient public ReadWriteLock Lock.readWriteLock = new ReentrantReadWriteLock();
	// END implementation refinement

	// declared methods without message views
	void Lock.lock(AccessKind accessKind)  {
		// BEGIN implementation refinement
		if (accessKind == AccessKind.READ) {
			readWriteLock.readLock().lock();
		}
		else {
			readWriteLock.writeLock().lock();
		}
		// END implementation refinement
	}
	
	void Lock.unlock(AccessKind accessKind) {
		// BEGIN implementation refinement
		if (accessKind == AccessKind.READ) {
			readWriteLock.readLock().unlock();
		}
		else {
			readWriteLock.writeLock().unlock();
		}
		// END implementation refinement
	}	
}

aspect LockMessageMixin {
	// methods shown in message views
	// empty
}

class LockImpl implements Lock {
	// implementation for complete class
	LockImpl() {};
}
