package ca.mcgill.sel.aspectoptima.aspects.nested;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.Collection;
import java.util.HashSet;
import java.util.Set;

import org.aspectj.lang.SoftException;
import org.aspectj.lang.annotation.AdviceName;
import org.aspectj.lang.reflect.MethodSignature;

import ca.mcgill.sel.aspectoptima.aspects.context.Context;
import ca.mcgill.sel.aspectoptima.aspects.tracing.Traced;
import ca.mcgill.sel.aspectoptima.aspects.transaction.TransactableMethod;

public interface NestedContext extends Context {
	// public method signatures from structural view
	NestedContext getParent();
	Set<NestedContext> getChildren();
}

aspect NestedContextAspect {
	// attributes & associations from structural view
	private Set<NestedContext> NestedContext.children = new HashSet<NestedContext>();
	private NestedContext NestedContext.parent;

	// declared methods without message views
	public NestedContext NestedContext.getParent() {
		// auto-generated getter implementation
		return this.parent;
	}
	
	void NestedContext.setParent(NestedContext parent) {
		// auto-generated setter implementation
		this.parent = parent;
	}
	
	void NestedContext.addChild(NestedContext child) {
		// BEGIN implementation refinement
		this.children.add(child);
		// END implementation refinement
	}
	
	public Set<NestedContext> NestedContext.getChildren() {
		// auto-generated getter implementation
		return this.children;
	}

	// methods shown in message views
	// empty
}
