package ca.mcgill.sel.aspectoptima.aspects.recovering;

import java.util.Set;

import ca.mcgill.sel.aspectoptima.aspects.deferring.DeferringContext;
import ca.mcgill.sel.aspectoptima.aspects.outcomeaware.Outcome;
import ca.mcgill.sel.aspectoptima.aspects.tracing.Traced;
import ca.mcgill.sel.aspectoptima.aspects.context.Context;

public interface RecoveringContextDeferring extends RecoveringContext, DeferringContext {
	// public method signatures from structural view
	// empty
}

aspect RecoveringContextDeferringAspect {
	// attributes & associations from structural view
	// empty
	
	// declared methods without message views
	// empty

	// methods shown in message views
	before(RecoveringContextDeferring target) : execution(void Context.contextCompleted()) && target(target) {
		Outcome outcome = target.getOutcome();
		/* FIXME throw exception if outcome == null */
		boolean succeeded = false;
		if (outcome != null) {
			succeeded = outcome.isPositive();
		}
		if (succeeded) {
			target.performUpdate();
		}
		Set<Traced> accessed = target.getAccessed();
		target.removeTraces(accessed);
	}
}
