package ca.mcgill.sel.aspectoptima.aspects.tracing;

import java.lang.reflect.Method;

import org.aspectj.lang.annotation.AdviceName;
import org.aspectj.lang.reflect.MethodSignature;

import ca.mcgill.sel.aspectoptima.aspects.traceable.Trace;
import ca.mcgill.sel.aspectoptima.aspects.traceable.Traceable;
import ca.mcgill.sel.aspectoptima.interfacing.ParticipantPool;

public interface Traced extends Traceable {
	// public method signatures from structural view
	// empty
}

aspect TracedAspect {
	// bind annotations to mandatory instantiation parameters
	declare parents : @TracedClass * implements Traced;
	
	// attributes & associations from structural view
	// empty
	
	// declared methods without message views
	// empty

	// methods shown in message views
	/** creates a Trace for each method call on a Traced method 
	 *  and adds it to the traceList of the context associated with the caller */
	@AdviceName("traceMethod")
	before(Traced target): execution(@TracedMethod * *.*(..)) && target(target) {
		Method m = ((MethodSignature) thisJoinPointStaticPart.getSignature()).getMethod();
		Trace trace = target.createTrace(m);
		TracingParticipant participant = (TracingParticipant) TracingParticipantStatic.getCurrent();
		TracingContext context = (TracingContext) participant.getContext();
		context.addTrace(trace);
	}
}
