package ca.mcgill.sel.aspectoptima.aspects.transaction;

import ca.mcgill.sel.aspectoptima.aspects.outcomeaware.BinaryOutcomeImpl;
import ca.mcgill.sel.aspectoptima.aspects.outcomeaware.Outcome;
import ca.mcgill.sel.aspectoptima.aspects.outcomeaware.OutcomeControllingParticipant;
import ca.mcgill.sel.aspectoptima.aspects.recovering.RecoveringParticipant;
import ca.mcgill.sel.aspectoptima.aspects.context.Context;
import ca.mcgill.sel.aspectoptimaomtt.aspects.outcomevotable.OutcomeVotableContext;
import ca.mcgill.sel.aspectoptimaomtt.aspects.outcomevotable.OutcomeVotableParticipant;
import ca.mcgill.sel.aspectoptimaomtt.aspects.terminatable.TerminatableContext;
import ca.mcgill.sel.aspectoptimaomtt.aspects.terminatable.TerminatableParticipant;

public interface TransactionParticipant extends RecoveringParticipant {
	// public method signatures from structural view
	void beginTransaction();
	void abortTransaction();
	void commitTransaction();
}

aspect TransactionParticipantAspect {
	// attributes & associations from structural view
	// empty
	
	// declared methods without message views
	// empty

	// public method signatures from structural view
	public void TransactionParticipant.beginTransaction() {
		this.createAndEnterContext();
	}

	public void TransactionParticipant.abortTransaction() {
		this.leaveContext();
	}

	public void TransactionParticipant.commitTransaction() {
		Outcome outcome = new BinaryOutcomeImpl(true);
		this.voteAndLeaveContext(outcome);
	}
	
	// BEGIN implementation refinement
	public boolean TransactionParticipant.isAlreadyTransacted() {
	// END implementation refinement
		boolean result = false;
		Context myContext = this.getContext();
		if (myContext != null) {
			result = true;
		}
		return result;
	}
}
