package ca.mcgill.sel.aspectoptima.conflictresolutions.checkpointingnested;

import java.util.HashSet;
import java.util.Set;

import ca.mcgill.sel.aspectoptima.aspects.checkpointing.Checkpointed;
import ca.mcgill.sel.aspectoptima.aspects.checkpointing.CheckpointingContext;
import ca.mcgill.sel.aspectoptima.aspects.nested.NestedContext;
import ca.mcgill.sel.aspectoptima.aspects.tracing.Traced;

privileged aspect CheckpointingContextAspect {
	// attributes & associations from structural view
	// empty
	
	// declared methods without message views
	// empty

	// methods shown in message views
	void around(NestedContext target) : execution(void CheckpointingContext.discardCheckpoints()) && target(target) {
		Set<Traced> accessed = ((CheckpointingContext) target).getAccessed();
		Set<Traced> toBeRemoved = new HashSet<Traced>();
		for (Traced t : accessed) {
			CheckpointingContext parent = (CheckpointingContext) target.getParent();
			if (parent != null) {
				boolean accessedByParent = parent.wasDirectlyAccessed(t);
				if (accessedByParent) {
					((Checkpointed) t).discardLastCheckpoint();
					toBeRemoved.add(t);
				}
			} else {
				((Checkpointed) t).discardLastCheckpoint();
				toBeRemoved.add(t);
			}
		}
		((CheckpointingContext) target).removeTraces(toBeRemoved);
	}
}

