package ca.mcgill.sel.aspectoptima.conflictresolutions.nestedtracing;

import java.lang.reflect.Method;
import java.lang.reflect.InvocationTargetException;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import org.aspectj.lang.reflect.MethodSignature;

import ca.mcgill.sel.aspectoptima.aspects.nested.NestedContext;
import ca.mcgill.sel.aspectoptima.aspects.traceable.Trace;
import ca.mcgill.sel.aspectoptima.aspects.tracing.Traced;
import ca.mcgill.sel.aspectoptima.aspects.tracing.TracingContext;
import ca.mcgill.sel.aspectoptima.aspects.nested.NestedContextAddChildrensResultsAspect;

privileged aspect TracingContextAspect {
	// attributes & associations from structural view
	// empty
	
	// declared methods without message views
	// empty

	// methods shown in message views
	boolean around(NestedContext target, Traced t) : execution(boolean TracingContext.wasAccessed(..)) && target(target) && args(t) {
		boolean accessed = proceed(target, t);
		if (!accessed) {
			Set<NestedContext> children = target.getChildren();
			Iterator<NestedContext> childrenIterator = children.iterator();
			while (childrenIterator.hasNext() && !accessed) {
				NestedContext c = childrenIterator.next();
				accessed = ((TracingContext) c).wasAccessed(t);
			}
		}
		return accessed;
	}
	
	public boolean TracingContext.wasDirectlyAccessed(Traced t) {
		return this.accessed.contains(t);
	}
}

aspect GetAccessedAddChildrensResultsAspect extends NestedContextAddChildrensResultsAspect<Set<Traced>> {
	public pointcut m(NestedContext target) : execution(Set<Traced> TracingContext.getAccessed()) && target(target);
}

aspect GetTracesAddChildrensResultsAspect extends NestedContextAddChildrensResultsAspect<List<Trace>> {
	public pointcut m(NestedContext target) : execution(List<Trace> TracingContext.getTraces()) && target(target);
}