package ca.mcgill.sel.aspectoptima.example.banking;

import java.util.ArrayList;
import java.util.Collection;

import org.junit.Test;

import ca.mcgill.sel.aspectoptima.example.banking.exception.AccountNotAvailableException;
import ca.mcgill.sel.aspectoptima.example.banking.exception.BankingException;
import ca.mcgill.sel.aspectoptima.example.banking.exception.InsufficientFoundsException;
import static org.junit.Assert.*;

public class BankingTest {
	@Test
	public void testSuccessfull() {
		Collection<Account> accounts = new ArrayList<Account>(2);
		Account a1 = new Account(1, 100.10f, -500);
		Account a2 = new Account(2, 200.20f, -500);
		accounts.add(a1);
		accounts.add(a2);
		Bank bank = new Bank(accounts);
		try {
			bank.transfer(1, 2, 500);
			assertEquals(-399.90f, a1.getBalance(),0);
			assertEquals(700.20f, a2.getBalance(),0);
		} catch (BankingException e) {
			e.printStackTrace();
		}
	}
	
	@Test
	public void testFail() {
		Collection<Account> accounts = new ArrayList<Account>(2);
		Account a1 = new Account(1, 100.10f, -500);
		Account a2 = new Account(2, 200.20f, -500);
		accounts.add(a1);
		accounts.add(a2);
		Bank bank = new Bank(accounts);
		boolean insufficient = false;
		try {
			bank.transfer(1, 2, 900);
	    } catch (InsufficientFoundsException e) {
	        insufficient = true;
		} catch (AccountNotAvailableException e) {
			e.printStackTrace();
		}
		assertTrue(insufficient);
		assertEquals(100.10f, a1.getBalance(),0);
		assertEquals(200.20f, a2.getBalance(),0);
	}
}
