package ca.mcgill.sel.aspectoptima.interfacing;

import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/** Specifies an abort condition for AspectOPTIMA transactions. <br>
 * will automatically be aborted whenever it throws a Throwable t such that
 * <code>t instanceof Parameter</code> is true. <br>
 * The parameter class needs to be a subclass of Throwable and defaults to Throwable.class.
 */
@Target( { ElementType.METHOD })
@Documented
@Retention(RetentionPolicy.RUNTIME)
public @interface AbortTransactionOnThrowing {
	Class<? extends Throwable> value() default Throwable.class;
}
