package ca.mcgill.sel.aspectoptima.test;

import org.junit.Test;
import static org.junit.Assert.*;

import ca.mcgill.sel.aspectoptima.aspects.accessclassified.AccessKind;
import ca.mcgill.sel.aspectoptima.aspects.deferring.*;

@DeferredClass
public class DeferringTest {
	int insideDeferringTest = 0;
	
	@Test
	public void testAbort() {
		ca.mcgill.sel.aspectoptima.test.AspectOPTIMATesting.beginDeferring();
		DeferringTest test = new DeferringTest();
		test.foo(1);
		test.bar(4,5);
		assertEquals(0, test.insideDeferringTest);
		ca.mcgill.sel.aspectoptima.test.AspectOPTIMATesting.end();
		assertEquals(0, test.insideDeferringTest);
	}
	
	@Test
	public void testCommit() {
		ca.mcgill.sel.aspectoptima.test.AspectOPTIMATesting.beginDeferring();
		DeferringTest test = new DeferringTest();
		test.foo(1);
		test.bar(4,5);
		assertEquals(0, test.insideDeferringTest);
		ca.mcgill.sel.aspectoptima.test.AspectOPTIMATesting.performUpdate();
		ca.mcgill.sel.aspectoptima.test.AspectOPTIMATesting.end();
		assertEquals(4, test.insideDeferringTest);
	}
	
	@DeferredMethod(AccessKind.READ)
	void foo(int a) {
		insideDeferringTest = a;
		bar(2,3);
	}
	
	@DeferredMethod(AccessKind.READ)
	void bar(int a, int b) {
		insideDeferringTest = a;
	}
}
