package ca.mcgill.sel.aspectoptimaomtt.aspects.blockable;

import java.lang.reflect.Method;
import java.util.Map;
import java.util.concurrent.Semaphore;

import ca.mcgill.sel.aspectoptima.aspects.context.Context;

interface BlockableContext extends Context {
	// empty to allow  multiple binding
}

class BlockableContextMessages {
	// static version of methods shown in message views
	static void releaseSemaphore(BlockableContext blockableContext, Map<String,String> bindingMap) {
		try {
			Class<? extends BlockableContext> blockableContextClass = blockableContext.getClass();
			Method getSemaphoreMethod = getGetSemaphoreMethod(blockableContextClass, bindingMap);
			Semaphore mySemaphore = (Semaphore) getSemaphoreMethod.invoke(blockableContext, (Object[]) null);
			mySemaphore.release();
		} catch (Exception e) {
			// swallow
			e.printStackTrace();
		}
	}
	
	// helper methods for access to bound fields and methods	
	static Method getGetSemaphoreMethod(Class<? extends BlockableContext> blockableContextClass, Map<String,String> bindingMap) throws SecurityException, NoSuchMethodException {
		String getSemaphoreName = (bindingMap == null) ? "getSemaphore" : bindingMap.get("getSemaphore");
		Method method = blockableContextClass.getDeclaredMethod(getSemaphoreName, (Class<?>[]) null);
		method.setAccessible(true);
		return method;
	}
}