package ca.mcgill.sel.aspectoptimaomtt.aspects.closable;

import ca.mcgill.sel.aspectoptima.aspects.context.Context;
import java.lang.Integer;
import ca.mcgill.sel.aspectoptimaomtt.aspects.collaborative.CollaborativeContext;

public interface ClosableContext extends CollaborativeContext {
	// public method signatures from structural view
	void setClosed(boolean closed);
	void setMaxParticipantCount(int maxParticipantCount);
}

aspect ClosableContextAspect {
	//* FIXME !!! FIND OUT WHY THIS ADVICE CAN'T BE FURTHER DOWN IN THE ASPECT */
	after(ClosableContext target) : execution(void CollaborativeContext.addParticipant(..)) && target(target) {
		boolean last = target.isLastAllowedParticipant(); 
		if (last) {
			target.setClosed(true);
		}
	}
	
	// attributes & associations from structural view
	private boolean ClosableContext.closed = false;
	private int ClosableContext.maxParticipantCount = Integer.MAX_VALUE;
	
	// declared methods without message views
	boolean ClosableContext.isClosed() {
		// auto-generated getter implementation
		return this.closed;
	}
	
	public void ClosableContext.setClosed(boolean closed) {
		// auto-generated setter implementation
		this.closed = closed;
	}
	
	public void ClosableContext.setMaxParticipantCount(int maxParticipantCount) {
		// auto-generated setter implementation
		this.maxParticipantCount = maxParticipantCount;
	}
	
	int ClosableContext.getMaxParticipantCount() {
		// auto-generated getter implementation
		return this.maxParticipantCount;
	}

	// methods shown in message views
	private boolean ClosableContext.isLastAllowedParticipant() {
		boolean last = false;
		int max = this.getMaxParticipantCount();
		int participants = this.getParticipantCount();
		if (participants == max) {
			last = true;
		}
		return last;
	}
}