package ca.mcgill.sel.aspectoptimaomtt.aspects.entrysynchronizing;

import ca.mcgill.sel.aspectoptimaomtt.aspects.blockable.BlockableContextForEntrySynchronizing;
import ca.mcgill.sel.aspectoptimaomtt.aspects.collaborative.CollaborativeContext;

public interface EntrySynchronizingContext extends CollaborativeContext, BlockableContextForEntrySynchronizing {
	// public method signatures from structural view
	void setMinParticipantCount(int minParticipantCount);
}

aspect EntrySynchronizingContextAspect {
	// attributes & associations from structural view
	private int EntrySynchronizingContext.minParticipantCount = 0;
	private int EntrySynchronizingContext.waitingParticipantCount = 0;
	
	// declared methods without message views
	private int EntrySynchronizingContext.getMinParticipantCount() {
		// auto-generated getter implementation
		return this.minParticipantCount;
	}
	
	public void EntrySynchronizingContext.setMinParticipantCount(int minParticipantCount) {
		// auto-generated setter implementation
		this.minParticipantCount = minParticipantCount;
	}
	
	private int EntrySynchronizingContext.getWaitingParticipantCount() {
		// auto-generated getter implementation
		return this.waitingParticipantCount;
	}
	
	void EntrySynchronizingContext.increaseWaitingParticipantCount() {
		// auto-generated incrementor implementation
		this.waitingParticipantCount++;
	}
	
	void EntrySynchronizingContext.decreaseWaitingParticipantCount() {
		// auto-generated decrementor implementation
		this.waitingParticipantCount--;
	}

	// methods shown in message views
	boolean EntrySynchronizingContext.isLastEnteringParticipant() {
		boolean last = false;
		int waiting = this.getWaitingParticipantCount();
		int min = this.getMinParticipantCount();
		if (waiting >= min) {
			last = true;
		}
		return last;
	}
}