package ca.mcgill.sel.aspectoptimaomtt.aspects.exitsynchronizing;

import ca.mcgill.sel.aspectoptimaomtt.aspects.blockable.BlockableParticipantForExitSynchronizing;
import ca.mcgill.sel.aspectoptimaomtt.aspects.collaborative.CollaborativeParticipant;
import ca.mcgill.sel.aspectoptima.aspects.context.Participant;

public interface ExitSynchronizingParticipant extends CollaborativeParticipant, BlockableParticipantForExitSynchronizing {
	// public method signatures from structural view
	// empty
}

aspect ExitSynchronizingParticipantAspect {
	// bind annotations to mandatory instantiation parameter interfaces
	declare parents : @ExitSynchronizingParticipantClass * implements ExitSynchronizingParticipant;
	
	// attributes & associations from structural view
	// empty
	
	// declared methods without message views
	// empty

	// methods shown in message views
	before(ExitSynchronizingParticipant target) : execution(void Participant.leaveContext()) && target(target){
		target.waitOrReleaseBeforeLeaving();
	}
	
	private void ExitSynchronizingParticipant.waitOrReleaseBeforeLeaving() {
		ExitSynchronizingContext myContext = (ExitSynchronizingContext) this.getContext();
		// BEGIN implementation refinement
		if (myContext != null) {
		// END implementation refinement
			myContext.increaseBlockedParticipantCount();
			boolean last = myContext.isLastExitingParticipant();
			if (last) {
				myContext.releaseExitSemaphore();
			}
			else {
				this.waitForExitSemaphore();
			}
			myContext.decreaseBlockedParticipantCount();
		// BEGIN implementation refinement
		}
		// END implementation refinement
	}
}