package ca.mcgill.sel.aspectoptimaomtt.aspects.outcomevoting;

import ca.mcgill.sel.aspectoptimaomtt.aspects.outcomevotable.OutcomeVotableParticipant;
import ca.mcgill.sel.aspectoptima.aspects.outcomeaware.Outcome;
import ca.mcgill.sel.aspectoptima.aspects.context.Participant;

public interface OutcomeVotingParticipant extends OutcomeVotableParticipant {
	// public method signatures from structural view
	// empty
}

aspect OutcomeVotingParticipantAspect {
	// bind annotations to mandatory instantiation parameter interfaces
	declare parents : @OutcomeVotingParticipantClass * implements OutcomeVotingParticipant;
	
	// attributes & associations from structural view
	// empty
	
	// declared methods without message views
	// empty

	// methods shown in message views
	before(OutcomeVotingParticipant target) : execution(void Participant.leaveContext()) && target(target) {
		OutcomeVotingContext myContext = (OutcomeVotingContext) target.getContext();
		if (myContext != null) {
			boolean voted = myContext.alreadyVoted(target);
			if (!voted) {
				Outcome vote = myContext.getDefaultVote();
				myContext.registerVote(vote, target);
			}
		}
	}
}