package ca.mcgill.sel.aspectoptimaomtt.aspects.pausable;

import java.util.Set;

import ca.mcgill.sel.aspectoptimaomtt.aspects.blockable.BlockableContextForPausable;
import ca.mcgill.sel.aspectoptimaomtt.aspects.collaborative.CollaborativeContext;
import ca.mcgill.sel.aspectoptimaomtt.aspects.collaborative.CollaborativeParticipant;
import ca.mcgill.sel.aspectoptima.aspects.context.Context;

public interface PausableContext extends CollaborativeContext, BlockableContextForPausable {
	// public method signatures from structural view
	void pauseContext();
}

aspect PausableContextAspect {
	// attributes & associations from structural view
	private boolean PausableContext.paused = false;
	
	// declared methods without message views
	private boolean PausableContext.isPaused() {
		// auto-generated getter implementation
		return this.paused;
	}
	
	private void PausableContext.setPaused(boolean paused) {
		// auto-generated setter implementation
		this.paused = paused;
	}

	// methods shown in message views
	public void PausableContext.pauseContext() {
		this.setPaused(true);
		Set<CollaborativeParticipant> participants = this.getParticipants();
		for (CollaborativeParticipant p : participants) {
			((PausableParticipant) p).setPaused(true);
		}
	}
	
	before(PausableContext target, PausableParticipant participant) : execution(void CollaborativeContext.addParticipant(..)) && target(target) && args(participant) {
		boolean paused = target.isPaused();
		if (paused) {
			participant.setPaused(true);
		}
	}
}