package ca.mcgill.sel.aspectoptimaomtt.aspects.shared;

import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * Marks an object as Shared for the AspectOPTIMA Framework. <br>
 * The needed Annotations @LockableObject and @AccessClassifiedClass are added automatically. <br>
 * Methods of Shared objects can be marked as Shared using @SharedMethod.
 */
@Target({ElementType.TYPE}) 
@Documented
@Retention(RetentionPolicy.RUNTIME)
public @interface SharedClass {
	// empty
}