package ca.mcgill.sel.aspectoptimaomtt.aspects.spawnsupporting;

import java.lang.reflect.Constructor;

import ca.mcgill.sel.aspectoptima.aspects.context.Participant;
import ca.mcgill.sel.aspectoptimaomtt.aspects.collaborative.CollaborativeParticipant;

public interface SpawnSupportingParticipant extends CollaborativeParticipant {
	// public method signatures from structural view
	SpawnSupportingParticipant spawnParticipant();
}

aspect SpawnSupportingParticipantAspect {
	// bind annotations to mandatory instantiation parameter interfaces
	declare parents : @SpawnSupportingParticipantClass * implements SpawnSupportingParticipant;
	
	// attributes & associations from structural view
	private boolean SpawnSupportingParticipant.spawned = false;
	
	// declared methods without message views
	public boolean SpawnSupportingParticipant.isSpawned() {
		// auto-generated getter implementation
		return this.spawned;
	}
	
	void SpawnSupportingParticipant.setSpawned(boolean spawned) {
		// auto-generated setter implementation
		this.spawned = spawned;
	}
	
	private SpawnSupportingParticipant SpawnSupportingParticipant.createNewParticipant() {
		// BEGIN implementation refinement
		try {
			Class<? extends SpawnSupportingParticipant> implementationClass = this.getClass();
			Constructor<? extends SpawnSupportingParticipant> constructor = implementationClass.getDeclaredConstructor((Class<?>[]) null);
			constructor.setAccessible(true);
			return constructor.newInstance((Object[]) null);
		} catch (Exception e) {
			/* swallow */
			e.printStackTrace();
		}
		return null;
		// END implementation refinement
	}
	
	// methods shown in message views
	public SpawnSupportingParticipant SpawnSupportingParticipant.spawnParticipant() {
		/* FIXME throw exception if context == null */
		SpawnSupportingParticipant result = this.createNewParticipant();
		result.setSpawned(true);
		SpawnSupportingContext myContext = (SpawnSupportingContext) this.getContext();
		result.enterContext(myContext);
		myContext.increaseSpawnedParticipantCount();
		return result;
	}
}