package ca.mcgill.sel.aspectoptimaomtt.aspects.terminatable;

import java.util.Set;

import ca.mcgill.sel.aspectoptimaomtt.aspects.collaborative.CollaborativeParticipant;
import ca.mcgill.sel.aspectoptimaomtt.aspects.pausable.PausableContext;
import ca.mcgill.sel.aspectoptimaomtt.interfacing.AspectOPTIMAOMTT;
import ca.mcgill.sel.aspectoptimaomtt.interfacing.OMTTThread;

public interface TerminatableContext extends PausableContext {
	// public method signatures from structural view
	void terminateContext(TerminatableParticipant terminator);
}

aspect TerminatableContextAspect {
	// attributes & associations from structural view
	// empty
	
	// declared methods without message views
	// empty

	// methods shown in message views
	public void TerminatableContext.terminateContext(TerminatableParticipant terminator) {
		Set<CollaborativeParticipant> participants = this.getParticipants();
		for (CollaborativeParticipant p : participants) {
			if (p != terminator) {
				OMTTThread thread = AspectOPTIMAOMTT.getThread(p);
				final TerminatableParticipant participant = (TerminatableParticipant) p;
				Runnable terminateRunnable = new Runnable() {
					public void run() {
						participant.terminateParticipant();
					};
				};
				thread.enqueue(terminateRunnable);
			}
		}
		terminator.terminateParticipant();
		this.contextCompleted();
	}
}