package ca.mcgill.sel.aspectoptimaomtt.example.travelagency;

import java.util.List;
import java.util.Random;

import ca.mcgill.sel.aspectoptima.aspects.accessclassified.AccessKind;
import ca.mcgill.sel.aspectoptima.aspects.recovering.UpdateStrategy;
import ca.mcgill.sel.aspectoptima.aspects.transaction.ConcurrencyControl;
import ca.mcgill.sel.aspectoptimaomtt.aspects.openmultithreadedtransaction.OMTTransactableClass;
import ca.mcgill.sel.aspectoptimaomtt.aspects.openmultithreadedtransaction.OMTTransactableMethod;

@OMTTransactableClass(updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING)
public class FlightBroker extends TravelBroker {
	int remainingSeats = new Random().nextInt();
	
	@OMTTransactableMethod(accessKind = AccessKind.WRITE, updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING, nested = true)
	void findAndAddOffer(List<Offer> offerList, Route route) {
		Offer offer = new FlightOffer(route, new Random().nextInt());
		offerList.add(offer);
		remainingSeats--;
	}
}
