package ca.mcgill.sel.aspectoptimaomtt.interfacing;

import java.util.concurrent.ExecutionException;
import java.util.concurrent.Future;

import ca.mcgill.sel.aspectoptima.interfacing.AspectOPTIMAInternal;
import ca.mcgill.sel.aspectoptima.interfacing.ParticipantPool;
import ca.mcgill.sel.aspectoptimaomtt.aspects.openmultithreadedtransaction.OMTTParticipant;
import ca.mcgill.sel.aspectoptimaomtt.aspects.openmultithreadedtransaction.OMTTransactableMethod;

public class AspectOPTIMAOMTTInternal {
	@SuppressWarnings("unchecked")
	public static OMTTParticipant getOMTTParticipant(String updateStrategy, String concurrencyControl, boolean nested) throws ClassNotFoundException {
		String variabilityEncoding = AspectOPTIMAInternal.getVariabilityEncoding(updateStrategy, concurrencyControl, nested);
		String participantClassName = OMTTParticipant.class.getName() + variabilityEncoding;
		Class<? extends OMTTParticipant> participantClass = (Class<? extends OMTTParticipant>) Class.forName(participantClassName);
		return ParticipantPool.getParticipant(participantClass);	
	}
	
	public static OMTTParticipant getOMTTParticipant(
			OMTTransactableMethod methodAnnotation) {
		try {
			Class<? extends OMTTParticipant> participantImplClass = getOMTTParticipantImplClass(methodAnnotation);
			return ParticipantPool.getParticipant(participantImplClass);
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}
		return null;
	}
	
	public static String getVariabilityEncoding(OMTTransactableMethod methodAnnotation) {
		String updateStrategy = methodAnnotation.updateStrategy().toString();
		String concurrencyControl = methodAnnotation.concurrencyControl().toString();
		String nested = methodAnnotation.nested() ? "Nested" : "";
		return updateStrategy + concurrencyControl + nested;
	}

	@SuppressWarnings("unchecked")
	private static Class<? extends OMTTParticipant> getOMTTParticipantImplClass(OMTTransactableMethod methodAnnotation) throws ClassNotFoundException {
		String variabilityEncoding = AspectOPTIMAOMTTInternal.getVariabilityEncoding(methodAnnotation);
		String participantImplClassName = OMTTParticipant.class.getName() + variabilityEncoding;// + "Impl";
		return (Class<? extends OMTTParticipant>) Class.forName(participantImplClassName);
	}
	
	public static OMTTThread createAndStartNewThreadWithoutResult(Runnable runnable) throws InterruptedException, ExecutionException {
		return AspectOPTIMAOMTT.createAndStartNewThreadWithoutResult(runnable);
	}
}
