package ca.mcgill.sel.aspectoptimaomtt.interfacing;

import java.util.Queue;
import java.util.concurrent.ConcurrentLinkedQueue;

public class OMTTThread extends Thread {
	private long sleepDurationOnEmptyQueue = 100;
	private boolean alive = true;
	private Queue<Runnable> runnableQueue = new ConcurrentLinkedQueue<Runnable>();
	
	protected OMTTThread(Runnable runnable) {
		this.runnableQueue.add(runnable);
	}
	
	@Override
	public void run() {
		while(this.alive) {
			if (!runnableQueue.isEmpty()) {
				Runnable next = this.runnableQueue.poll();
				next.run();
			}
			else {
				try {
					Thread.sleep(this.sleepDurationOnEmptyQueue);
				} catch (InterruptedException e) {
					/* TODO Auto-generated catch block */
					e.printStackTrace();
				}
			}
		}
	}
	
	public void enqueue(Runnable runnable) {
		this.runnableQueue.add(runnable);
	}
	
	public void kill() {
		this.alive = false;
	}
	
	public void setSleepDurationOnEmptyQueue(long d) {
		this.sleepDurationOnEmptyQueue = d;	
	}
}
