package ca.mcgill.sel.aspectoptimaomtt.test;

import ca.mcgill.sel.aspectoptima.aspects.context.Context;
import ca.mcgill.sel.aspectoptima.aspects.context.Participant;
import ca.mcgill.sel.aspectoptimaomtt.aspects.closable.ClosableContext;
import ca.mcgill.sel.aspectoptimaomtt.aspects.closable.ClosableParticipant;
import ca.mcgill.sel.aspectoptimaomtt.aspects.collaborative.CollaborativeContext;
import ca.mcgill.sel.aspectoptimaomtt.aspects.collaborative.CollaborativeParticipant;
import ca.mcgill.sel.aspectoptimaomtt.aspects.entrysynchronizing.EntrySynchronizingContext;
import ca.mcgill.sel.aspectoptimaomtt.aspects.entrysynchronizing.EntrySynchronizingParticipant;
import ca.mcgill.sel.aspectoptimaomtt.aspects.exitsynchronizing.ExitSynchronizingParticipant;
import ca.mcgill.sel.aspectoptimaomtt.aspects.openmultithreadedtransaction.OMTTParticipant;
import ca.mcgill.sel.aspectoptimaomtt.aspects.openmultithreadedtransaction.OMTTParticipantCheckpointingTwoPhaseLocking;
import ca.mcgill.sel.aspectoptimaomtt.aspects.openmultithreadedtransaction.OMTTParticipantCheckpointingTwoPhaseLockingNested;
import ca.mcgill.sel.aspectoptimaomtt.aspects.openmultithreadedtransaction.OMTTParticipantDeferringTwoPhaseLocking;
import ca.mcgill.sel.aspectoptimaomtt.aspects.openmultithreadedtransaction.OMTTParticipantDeferringTwoPhaseLockingNested;
import ca.mcgill.sel.aspectoptimaomtt.aspects.outcomevoting.OutcomeVotingParticipant;
import ca.mcgill.sel.aspectoptimaomtt.aspects.spawnsupporting.SpawnSupportingParticipant;
import ca.mcgill.sel.aspectoptima.aspects.outcomeaware.OutcomeAwareContext;
import ca.mcgill.sel.aspectoptima.interfacing.ParticipantPool;

public class AspectOPTIMAOMTTTesting {
	public static void beginCheckpointed2PLOMTT() {
		ParticipantPool
				.begin(OMTTParticipantCheckpointingTwoPhaseLocking.class);
	}

	public static void beginDeferred2PLOMTT() {
		ParticipantPool
				.begin(OMTTParticipantDeferringTwoPhaseLocking.class);
	}

	public static void beginDeferredOVOMTT() {
		/* ParticipantPool.begin(TransactionDeferringOVParticipant.class); */
	}

	public static void beginCheckpointed2PLNestedOMTT() {
		ParticipantPool
				.begin(OMTTParticipantCheckpointingTwoPhaseLockingNested.class);
	}

	public static void beginDeferred2PLNestedOMTT() {
		ParticipantPool
				.begin(OMTTParticipantDeferringTwoPhaseLockingNested.class);
	}

	public static void beginCollaborative() {
		ParticipantPool.begin(CollaborativeParticipant.class);
	}

	public static Object getActualCollaborativeParticipant() {
		return ParticipantPool
				.getParticipant(CollaborativeParticipant.class);
	}
	
	public static Object getActualParticipant() {
		return ParticipantPool
				.claimParticipant();
	}

	public static Object getActualCollaborativeContext() {
		CollaborativeParticipant p = ParticipantPool
				.getParticipant(CollaborativeParticipant.class);
		return p.getContext();
	}
	
	public static Object getActualContext() {
		Participant p = ParticipantPool.claimParticipant();
		return p.getContext();
	}

	public static void join(Object c) {
		CollaborativeParticipant p = ParticipantPool
				.getParticipant(CollaborativeParticipant.class);
		p.joinContext((CollaborativeContext) c);
	}

	public static void beginClosable() {
		ParticipantPool.begin(ClosableParticipant.class);
	}

	public static void setMaxParticipantCount(int m) {
		Participant p = ParticipantPool
				.claimParticipant(ClosableParticipant.class);
		ClosableContext c = (ClosableContext) p.getContext();
		c.setMaxParticipantCount(m);
	}

	public static void joinClosable(Object c) {
		CollaborativeParticipant p = ParticipantPool
				.getParticipant(ClosableParticipant.class);
		p.joinContext((CollaborativeContext) c);
	}
	
	public static void beginSpawnSupporting() {
		ParticipantPool.begin(SpawnSupportingParticipant.class);
	}
	
	public static void joinSpawnSupporting(Object c) {
		CollaborativeParticipant p = ParticipantPool
				.getParticipant(SpawnSupportingParticipant.class);
		p.joinContext((CollaborativeContext) c);
	}

	public static SpawnSupportingParticipant spawnParticipant() {
		SpawnSupportingParticipant p = ParticipantPool
				.getParticipant(SpawnSupportingParticipant.class);
		return p.spawnParticipant();
	}
	
	public static SpawnSupportingParticipant spawnOMTTParticipant() {
		SpawnSupportingParticipant p = ParticipantPool
				.getParticipant(OMTTParticipant.class);
		return p.spawnParticipant();
	}
	
	public static void setThreadLocalParticipant(Object value) {
		ParticipantPool.setThreadLocalParticipant((Participant) value);
	}

	public static void beginExitSynchronizing() {
		ParticipantPool.begin(ExitSynchronizingParticipant.class);
	}

	public static void joinExitSynchronizing(Object c) {
		CollaborativeParticipant p = ParticipantPool
		.getParticipant(ExitSynchronizingParticipant.class);
		p.joinContext((CollaborativeContext) c);
	}

	public static Object beginWithoutEnterEntrySynchronizing() {
		Participant participant = ParticipantPool.getParticipant(EntrySynchronizingParticipant.class);
		return participant.createContext();
	}
	
	public static void enterEntrySynchronizing(Object c) {
		Participant participant = ParticipantPool.getParticipant(EntrySynchronizingParticipant.class);
		participant.enterContext((Context) c);
	}

	public static void joinEntrySynchronizing(Object c) {
		CollaborativeParticipant p = ParticipantPool
		.getParticipant(EntrySynchronizingParticipant.class);
		p.joinContext((CollaborativeContext) c);
	}
	
	public static void joinOMTT(Object c) {
		CollaborativeParticipant p = ParticipantPool
		.getParticipant(OMTTParticipantCheckpointingTwoPhaseLocking.class);
		p.joinContext((CollaborativeContext) c);
	}

	public static void setMinParticipantCount(int m, Object c) {
		((EntrySynchronizingContext) c).setMinParticipantCount(m);
	}

	public static void beginOutcomeVoting() {
		ParticipantPool.begin(OutcomeVotingParticipant.class);
	}

	public static void joinOutcomeVoting(Object c) {
		CollaborativeParticipant p = (CollaborativeParticipant) (ParticipantPool
		.getParticipant(OutcomeVotingParticipant.class));
		p.joinContext((CollaborativeContext) c);
	}
	
	public static boolean getOutcome(Object c) {
		return ((OutcomeAwareContext) c).getOutcome().isPositive();
	}
}
