package ca.mcgill.sel.aspectoptimaomtt.test;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotSame;

import org.junit.Test;


public class ClosableTest {
	@Test
	public void test() {
		AspectOPTIMAOMTTTesting.beginClosable();
		AspectOPTIMAOMTTTesting.setMaxParticipantCount(2);
		/* let one participant join now */
		Object c = AspectOPTIMAOMTTTesting.getActualCollaborativeContext();
		ClosableRunnable r = new ClosableRunnable(c);
		Thread t = new Thread(r);
		t.start();
		/* wait for this thread to die */
		try {
			t.join();
			System.out.println("c " + c);
			assertNotSame(null, c);
			System.out.println("r.newContext " + r.newContext);
			assertEquals(c, r.newContext);
			System.out.println("AspectOPTIMAOMTTTesting.getActualCollaborativeParticipant() " + AspectOPTIMAOMTTTesting.getActualCollaborativeParticipant());
			System.out.println("r.newPartcipant " + r.newPartcipant);
			assertNotSame(AspectOPTIMAOMTTTesting.getActualCollaborativeParticipant(), r.newPartcipant);
			
			/* try to let another participant join */
			ClosableRunnable r2 = new ClosableRunnable(c);
			Thread t2 = new Thread(r2);
			t2.start();
			/* wait for this thread to die */
			try {
				t2.join();
				System.out.println("c " + c);
				assertNotSame(null, c);
				System.out.println("r2.newContext " + r2.newContext);
				assertNotSame(c, r2.newContext);
				System.out.println("AspectOPTIMAOMTTTesting.getActualCollaborativeParticipant() " + AspectOPTIMAOMTTTesting.getActualCollaborativeParticipant());
				System.out.println("r2.newPartcipant " + r2.newPartcipant);
				assertNotSame(AspectOPTIMAOMTTTesting.getActualCollaborativeParticipant(), r2.newPartcipant);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}
}

class ClosableRunnable implements Runnable {
	Object context;
	Object newContext;
	Object newPartcipant;
	
	
	public ClosableRunnable(Object context) {
		this.context = context;
	}

	@Override
	public void run() {
		AspectOPTIMAOMTTTesting.joinClosable(context);
		newContext = AspectOPTIMAOMTTTesting.getActualCollaborativeContext();
		newPartcipant = AspectOPTIMAOMTTTesting.getActualCollaborativeParticipant();
	}
}