package ca.mcgill.sel.aspectoptimaomtt.test;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotSame;

import org.junit.Test;


public class CollaborativeTest {
	@Test
	public void test() {
		AspectOPTIMAOMTTTesting.beginCollaborative();
		Object c = AspectOPTIMAOMTTTesting.getActualCollaborativeContext();
		CollaborativeRunnable r = new CollaborativeRunnable(c);
		Thread t = new Thread(r);
		t.start();
		/* wait for this thread to die */
		try {
			t.join();
			System.out.println("c " + c);
			assertNotSame(null, c);
			System.out.println("r.newContext " + r.newContext);
			assertEquals(c, r.newContext);
			System.out.println("AspectOPTIMAOMTTTesting.getActualCollaborativeParticipant() " + AspectOPTIMAOMTTTesting.getActualCollaborativeParticipant());
			System.out.println("r.newPartcipant " + r.newPartcipant);
			assertNotSame(AspectOPTIMAOMTTTesting.getActualCollaborativeParticipant(), r.newPartcipant);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}
	
	@Test
	public void test2times2() {
		AspectOPTIMAOMTTTesting.beginCollaborative();
		Object c = AspectOPTIMAOMTTTesting.getActualCollaborativeContext();
		CollaborativeRunnable r = new CollaborativeRunnable(c);
		Thread t = new Thread(r);
		t.start();
		/* wait for this thread to die */
		try {
			t.join();
			System.out.println("c " + c);
			assertNotSame(null, c);
			System.out.println("r.newContext " + r.newContext);
			assertEquals(c, r.newContext);
			System.out.println("AspectOPTIMAOMTTTesting.getActualCollaborativeParticipant() " + AspectOPTIMAOMTTTesting.getActualCollaborativeParticipant());
			System.out.println("r.newPartcipant " + r.newPartcipant);
			assertNotSame(AspectOPTIMAOMTTTesting.getActualCollaborativeParticipant(), r.newPartcipant);
			
			CollaborativeRunnable2 r2 = new CollaborativeRunnable2();
			Thread t2 = new Thread(r2);
			t2.start();
			/* wait for this thread to die */
			try {
				t2.join();
				Object c3 = r2.newContext;
				CollaborativeRunnable r3 = new CollaborativeRunnable(c3);
				Thread t3 = new Thread(r3);
				t3.start();
				/* wait for this thread to die */
				try {
					t3.join();
					System.out.println("c3 " + c3);
					assertNotSame(null, c3);
					System.out.println("r3.newContext " + r3.newContext);
					assertEquals(c3, r3.newContext);
					System.out.println("AspectOPTIMAOMTTTesting.getActualCollaborativeParticipant() " + AspectOPTIMAOMTTTesting.getActualCollaborativeParticipant());
					System.out.println("r3.newPartcipant " + r.newPartcipant);
					assertNotSame(AspectOPTIMAOMTTTesting.getActualCollaborativeParticipant(), r3.newPartcipant);
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}
}

class CollaborativeRunnable implements Runnable {
	Object context;
	Object newContext;
	Object newPartcipant;
	
	
	public CollaborativeRunnable(Object context) {
		this.context = context;
	}

	@Override
	public void run() {
		AspectOPTIMAOMTTTesting.join(context);
		newContext = AspectOPTIMAOMTTTesting.getActualCollaborativeContext();
		newPartcipant = AspectOPTIMAOMTTTesting.getActualCollaborativeParticipant();
	}
}

class CollaborativeRunnable2 implements Runnable {
	Object newContext;
	Object newPartcipant;

	@Override
	public void run() {
		AspectOPTIMAOMTTTesting.beginCollaborative();
		newContext = AspectOPTIMAOMTTTesting.getActualCollaborativeContext();
		newPartcipant = AspectOPTIMAOMTTTesting.getActualCollaborativeParticipant();
	}
}
