package ca.mcgill.sel.aspectoptimaomtt.test;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotSame;

import org.junit.Test;


public class SpawnSupportingTest {
	@Test
	public void test() {
		AspectOPTIMAOMTTTesting.beginSpawnSupporting();
		Object c = AspectOPTIMAOMTTTesting.getActualCollaborativeContext();
		Object spawned = AspectOPTIMAOMTTTesting.spawnParticipant();
		SpawnSupportingRunnable r = new SpawnSupportingRunnable(spawned);
		Thread t = new Thread(r);
		t.start();
		/* wait for this thread to die */
		try {
			t.join();
			System.out.println("c " + c);
			assertNotSame(null, c);
			System.out.println("r.newContext " + r.newContext);
			assertEquals(c, r.newContext);
			System.out.println("AspectOPTIMAOMTTTesting.getActualCollaborativeParticipant() " + AspectOPTIMAOMTTTesting.getActualCollaborativeParticipant());
			System.out.println("r.newPartcipant " + r.newPartcipant);
			assertNotSame(AspectOPTIMAOMTTTesting.getActualCollaborativeParticipant(), r.newPartcipant);
			System.out.println("r.spawned " + r.spawned);
			assertEquals(r.newPartcipant, r.spawned);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}
}

class SpawnSupportingRunnable implements Runnable {
	Object newContext;
	Object newPartcipant;
	Object spawned;
	
	public SpawnSupportingRunnable(Object spawned) {
		this.spawned = spawned;
	}

	@Override
	public void run() {
		AspectOPTIMAOMTTTesting.setThreadLocalParticipant(spawned);
		newContext = AspectOPTIMAOMTTTesting.getActualCollaborativeContext();
		newPartcipant = AspectOPTIMAOMTTTesting.getActualCollaborativeParticipant();
	}
}